function help_msg( input )


switch input
    % Step 1 - Marquers Detection
    case 's01m01'
    warndlg2(['Use Marker from fMRI Recording:',10,...
        'Use this option if the EEG dataset was recorded with a marker coding the timing onset of each MR volume (uses the EEG.event structure)', 10,...
        '    ',10,...
        'Marker:',10,...
        '     Choose the marker that codes the fMRI volume onsets from the drop-down menu. When selecting a marker, a plot of the first 7 fMRI Volumes will appear. A red cross indicates the fMRI volume onsets.',10,...
        ' ',10,...
        'Marker per Artifact:',10,...
        '     Use this option if each Marker corresponds to the start of each artifact',10,...
        'Marker per Slice:',10,...
        '     Use this option if each Marker corresponds to the begining of each slice of the artifact',10,...
        '    ',10,' '],'Use Marker from fMRI recording');
    
    case 's01m02'
    warndlg2(['By choosing this option the time onsets of the fMRI volumes plug-in are estimated using an autocorrelation method. The algorithm requires an approximate value of the repetition time (TR) of the fMRI recording. For continuous fMRI recordings (no "silent gap") it might require more accurate values (+- 50ms). Around the specified TR fMRI volume onsets are identified by a threshold criterion that takes the first derivative of the signal into account. After all settings are defined, press the Read fMRI volumes onset button. A plot of the first 7 Markers will appear. A red cross indicates the fMRI volume onsets. If the volume onset detection fails, an error message is generated and the user has to change the settings before proceeding.',10,...
        ' ', 10,...
        'Specify approximate fMRI repetition rate (TR):',10,...
        '    Time between two consecutive fMRI volume in milli-seconds. For continuous fMRI recordings (''no silent gap'') this number has to be quite accurate (+-50ms).',10,...
        '    ',10,...
        'EEG reference channel:',10,...
        '    Here the user can specify a particular EEG channel on which the detection method will be based on.. Auto option will automatically select the channel with median variance. Make sure that the channel selected is not an accidentally unplugged electrode. Users can check the channel with the Preview button.',10,...
        '    ',10,...
        'Preview:',10,...
        '    It plots the first derivative of selected channel. It might be useful to estimate a value for the Artifact Threshold. This button is only available if an EEG reference channel is selected.',10,...
        '    ',10,...
        'Threshold for fMRI artifact detection:',10,...        
        '    Threshold that defines the occurrence of an fMRI gradient artifact. The first derivative (gradient value) of the EEG signal is taken into account. It can be specified as an absolute value (in micro volts per data point) or in percentage relative to the maximum value of the gradient of the artifact signal. Use the ''Preview'' button to adjust to dedicated values.',10,' '],'Manual fMRI volume onsets detection');
    % Step 2 - Artifact Onset & Offset
    case 's02m01'
    warndlg2(['Choose this option if you have an fMRI recording without silent gaps. If selected, the ''Start'' of the artifact period is defined as the volume onset (as defined in ''step 1''). The ''End'' of the Artifact will be the time point immediately before the subsequent volume onset marker. (i.e. Start = 0, End = TR).',10,...
        '    ',10,...
        'Tips:',10,...
        '    You may need to adjust the start of the artifact (onset) to a position previous on time of what is refered. You may Zoom to see detailed graph information',10,...
        '    You can write the time or use the +/- buttons to adjust the position of the start and end on the artifact. Alternatively, you may use to select the start or end with the mouse, using the buttons "Select Point from Graph".',10,...
        '    ',10,' '],'Use continuous recording (Marker to Marker)');
    case 's02m02'
    warndlg2(['If selected, the user can adjust the ''Start'' and ''End'' of the artifact relative to the first volume onset marker (as defined in ''step 1''). ''Start'' and ''End'' values must be in milliseconds and will be positive or negative depending if they are after or before the volume onset marker position (respectively). Alternatively, user may select graphically Start and End points by pushing ''Select Point from graph''. A zoom tool is available and the buttons ''+'' and ''-'' can be used adjust the artifact position. Note: Overlapping artifact periods (negative ''silent gap'') are not cannot be negative.',10,...
        '    ',10,' '],'Manually adjust Start and End values of the artifact period');
        
    % Step 3 - Baseline Correction
    case 's03m01'
    warndlg2(['The artifact period itself (as defined in ''step 2'') is used as baseline epoch. This option is recommended for continuous fMRI recordings without ''silent gap''. Each baseline interval (equiv. to artifact volume) is mean corrected.',10,...
        '    ',10,' '],'Use mean of artifact period itself');

    case 's03m02'
    warndlg2(['The period of the ''silent gap'' (as defined in ''step 2'') is used as baseline epoch (i.e. BL start=''stop of artifact volume t '', BL stop=''start of artifact volume t+1'') This option is only available if silent gaps exists. If selected, each artifact interval as defined in ''step 2'' is averaged and shifted to the average of precedent silent gap.',10,...
        '    ',10,' '],'Use mean of preceding silent gap');
            
    case 's03m03'
    warndlg2(['If selected, each artifact interval as defined on step 2 is averaged and shifted to the mean of defined time interval. The time interval is defined in the BL start and BL stop fields. The values are in milliseconds and are be positive or negative depending if they are after or before the marker, respectively.',10,...
        '    ',10,' '],'Use mean of a specific time interval');
        
    case 's03m04'
    warndlg2(['This option corrects borders at the beginning and end of the fMRI recording. In this case, the whole initial part of dataset (until the beginning of fMRI recording) is averaged and then shifted to the average of the first corrected artifact. In the same way, the last part of the dataset (from the end of fMRI recording until the end of the dataset) is averaged and then shifted to the average of last artifact corrected. If selected, it will take effect after baseline correction as defined above',10,...
        '    ',10,...
        '    ',10,' '],'Advanced Option: Baseline correct data before and after the fMRI recording:');
            
    % Step 4 - Correction Methods
    case 's04m01'
    warndlg2(['This is a modification of the Moving Average algorithm which yields a better artifact correction in case of abrupt head movements of the subject. The head movements of the subject (as identified by the realignment procedure of the fMRI preprocessing) are taken into account to identify the appropriate artifact volumes that constitute the individual correction templates. Basically, movements above threshold act as a barrier in order to avoid averaging over discontinuities of the artefact properties. If no head movements are present this methods is equivalent to the ''Moving average'' correction algorithm. A correction matrix is showing graphically which artifact volumes (x-axis) constitute to the individual template for the correction of the respective artifact volume (y-axis).',10,...
        'See Moosmann et al. Neuroimage, 2009 for more details.',10,...
        '    ',10,...
        'Number of Artifacts that constitute the template: ',10,...
        '    Number of Number of artifacts volumes that constitute the individual templates of the ''Realignment Parameter Informed'' correction algorithm. A typical number is 25 artifact volumes',10,...
        '    ',10,...
        'Threshold of head movement (in millimeter per data point):',10,...
        '    The translational realignment parameters of the fMRI realignment procedure are transformed to a single parameter by Euclidian metric, resulting in a measure for the speed of the movements. This motion parameter is then thresholded so that only critical abrupt movements remained, and not slow drifts of the head. Typical values are ~0.5mm for 1.5T and ~0.3mm for 3T fMRI recordings (@ a EEG sampling rate of 5kHz).',10,...
        '    ',10,...
        'Realignment Parameter File:',10,...
        '    Choose the realignment parameter file from the SPM realignment procedure. Typically it is called "rp_*.txt" and is located in the same folder as the fMRI image files. If fMRI images are excluded before the realignment procedure (to allow T1 saturation) the number of volume onset markers as identified in ''step 1 ''(equiv. to the number of artifact volumes to correct) and the number of lines in the realignment parameter file (equiv. to the number of fMRI image files used for the realignment procedure) do not match. In this case the movement vector is zero-padded.',10,...
        '    ',10,' '],'Correction Method - Realignment Parameter Informed');
        
    case 's04m02'
    warndlg2(['This artefact correction method is based on Allen et al (Neuroimage, 2000) and calculates individual templates which are subtracted from respective artefact periods to correct the MR-imaging related artefacts. The templates are calculated from a moving average of a constant number of artefact volumes centred around the artefact volume to correct. A correction matrix is showing graphically which artifact volumes (x-axis) constitute to the individual template for the correction of the respective artifact volume (y-axis)',10,...
        '    ',10,...
        'Number of artifacts volumes that constitute the templates:',10,...
        '    Number of Number of artifacts volumes that constitute the individual templates of the Moving Average correction algorithm. A typical number is 25 artifact volumes.',10,...
        '    ',10,' '],'Correction Method - Moving Average');
            
    case 's04m03'
    warndlg2(['To be published in next version',10,...
        '    ',10,' '],'Correction Method - Adapted Template Correction');
        
    case 's04m04'
    warndlg2(['This method uses all artifact volumes with the same weight to calculate the correction template.',10,...
        '    ',10,' '],'Correction Method - All artifacts volumes');
    case 's04m05'
    warndlg2(['This option allows users to load their own correction matrix by Matlab (*.MAT) file. This file must contain a variable called ''weighting_matrix''. This variable must be quadratic [N x N], where N is the number of artifacts considered for correction. If N is smaller than the number of fMRI volume onsets identified in ''step 1'', the first (M-N) artifacts will be discard from correction.',10,...
        '    ',10,' '],'Correction Method - Load correction matrix file');
    
    % Step 5 - Filtering Option
    case 's05m01'
    warndlg2(['Choose new (lower) sampling rate. Use this option to reduce the size of your dataset. This option uses the pop_resample() function from EEGLAB.',10,...
        '    ',10,...
        'New sampling rate [Hz]',10,...
        '    Define new sampling rate in Hz, e. g. 200 Hz',10,...
        '    ',10,' '],'Resample dataset');
        
    case 's05m02'
    warndlg2(['Band pass filter data using an elliptic IIR filter. Forward and reverse filtering are used to avoid phase distortions. It uses the pop_iirfilt()function from EEGLAB. It applies consecutively the low-pass filter and then the high-pass filter.',10,...
        '    ',10,...
        'From/To:',10,...
        '    Specify the filter border is Hz, (e.g From 1 Hz To 70 Hz)',10,...
        '    ',10,' '],'Apply band-pass filter');

    % Step 6 - Resume
    case 's06m01'
    warndlg2(['When the artifact removal process is complete, a representative corrected EEG stretch is shown. It is possible to save a log file with all defined parameters',10,...
        '    ',10,...
        'Tips:',10,...
        '    You can view different channels on the Dropbob above the Graphic',10,...
        '    You may Choose to Save a full report log file, which will contain all the parameters choosed and detected.',10,...
        '    You may also choose ''Append Commands (from EEG.history)'' option and the command lines to produce the same result will be appended to the Report Log.',10,...        
        '    ',10,' '],'Overview and Report Log');
end

        